Bug 732592 - [iwl4965] kernels >= 2.6.40 break wlan performance and stability
Summary: [iwl4965] kernels >= 2.6.40 break wlan performance and stability
Keywords:
Status: CLOSED INSUFFICIENT_DATA
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 15
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Stanislaw Gruszka
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-08-23 02:47 UTC by Nils Philippsen
Modified: 2012-06-11 14:42 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-06-06 19:01:06 UTC


Attachments (Terms of Use)
/var/log/messages: lines pertaining to wedged WLAN hardware/firmware (13.30 KB, text/plain)
2011-09-01 15:14 UTC, Nils Philippsen
no flags Details
dmesg excerpt (16.88 KB, text/plain)
2011-09-04 11:28 UTC, Nils Philippsen
no flags Details
/var/log/kernel since last reload of iwl4965 module (159.43 KB, application/x-bzip)
2011-11-03 16:22 UTC, Nils Philippsen
no flags Details
/var/log/kernel of 3.1.0-7 with debugging as requested (826.41 KB, application/x-bzip)
2011-11-10 09:18 UTC, Nils Philippsen
no flags Details

Description Nils Philippsen 2011-08-23 02:47:49 UTC
Description of problem:
I have a Dell Latitude D830 with an Intel Wireless 4965 chipset. With kernels 2.6.40-4.fc15 and 2.6.40.3-0.fc15, WLAN reliability and speed are very bad compared to 2.6.38.6-26.rc1.fc15 -- speed according to iwconfig 1-5.5Mbps vs. 9-36Mbps, measured with iperf 1.2~1.6 Mbps vs. 3.3~9.3Mbps, regular dropped connections/reconnects vs. none.

Version-Release number of selected component (if applicable):
kernel-2.6.40-4.fc15.x86_64         <---  bad
kernel-2.6.40.3-0.fc15.x86_64       <---  bad
kernel-2.6.38.6-26.rc1.fc15.x86_64  <--- good

How reproducible:
Reproducible.

Steps to Reproduce:
1. Boot one of the kernels
2. Use WLAN
  
Actual results, expected results: see above -- kernels 2.6.40 vs. 2.6.38.

Additional info:
Uses iwlagn driver on 2.6.38, iwl4965 on 2.6.40 kernels.

Comment 1 Nils Philippsen 2011-08-23 02:50:39 UTC
Another tidbit: this is against a Linksys WRT54GS Router/Access Point (802.11g).

Comment 2 Thomas Spura 2011-08-31 11:46:50 UTC
(In reply to comment #0)
> regular dropped connections/reconnects vs. none.

The connection doesn't "drop" here, it kills the access point :)

After a while, when the access point is restarted, I can connect again and after a minute or two, it's killed again and does a restart.

Access point: Speedport W503 V
Laptop: Lenovo x220 i5:
http://www.smolts.org/client/show/pub_7b47388d-803a-495e-a4fc-7b729383cef4

The problem is with:
kernel-2.6.40.3-0.fc15.x86_64

Working with:
kernel-2.6.38.8-35.fc15.x86_64 (and before)

Comment 3 Thomas Spura 2011-08-31 13:01:02 UTC
This might be a dub of bug 733269.

The workaround from there seem to work here too:
'add the line "options iwlagn 11n_disable=1" in /etc/modprobe.d/modprobe.conf.'

(But I have iwlagn in both cases of kernels).

The new kernel from:
http://koji.fedoraproject.org/koji/buildinfo?buildID=261186

fixes my issues.

Comment 4 Nils Philippsen 2011-09-01 15:00:32 UTC
(In reply to comment #3)
> This might be a dub of bug 733269.
> 
> The workaround from there seem to work here too:
> 'add the line "options iwlagn 11n_disable=1" in /etc/modprobe.d/modprobe.conf.'

I don't think so, my access point is 802.11g only, 11n_disable shouldn't influence my setup AIUI.

Comment 5 Nils Philippsen 2011-09-01 15:12:50 UTC
(In reply to comment #3)
> http://koji.fedoraproject.org/koji/buildinfo?buildID=261186

Connection speed maxes is 9Mbps (iwconfig)/7Mbps (iperf) with this kernel, the laptop being half a meter from the access point. I'll monitor stability.

NB: I had the 2.6.38 kernel running for a while and noticed hard lockups of the WLAN hardware after a few hours of uptime/use with it as well. I'll attach a file with the lines of /var/log/messages that seem relevant to me.

Comment 6 Nils Philippsen 2011-09-01 15:14:07 UTC
Created attachment 521033 [details]
/var/log/messages: lines pertaining to wedged WLAN hardware/firmware

Comment 7 Nils Philippsen 2011-09-04 11:28:49 UTC
Created attachment 521366 [details]
dmesg excerpt

This time, WLAN got wedged on 2.6.40.4-5.fc15.x86_64.

Comment 8 Stanislaw Gruszka 2011-09-05 09:02:52 UTC
> Sep  1 15:23:11 gibraltar kernel: [34348.077035] iwlagn 0000:0c:00.0: Queue 2 stuck for 2000 ms.
> Sep  1 15:23:11 gibraltar kernel: [34348.077048] iwlagn 0000:0c:00.0: On demand firmware reload
> Sep  1 15:23:12 gibraltar kernel: [34348.086849] iwlagn 0000:0c:00.0: MAC is in 

First message indicate that firmare hangs. It happens after about 9 hours, driver do something bad that's crash the firmware. I'm not sure how to track it down sine this happen after so much time, and gathering and analysing 9h debug logs could be annoying.

Perhaps lets try first solve bad performance problem. Please configure rsyslog like described in "Configure syslog to log kernel debug messages" in  https://fedoraproject.org/wiki/DebugWireless .

Then reload driver:

modprobe -r iwl4965
echo > /var/log/kernel
modprobe iwl4965 debug=0x47ffffff

Do some traffic on the network which show bad performance and attach /var/log/kernel here. Thanks.

Comment 9 Nils Philippsen 2011-11-03 16:22:41 UTC
Created attachment 531602 [details]
/var/log/kernel since last reload of iwl4965 module

I just updated to F-16 and encountered this issue once again (I shirked this on F-15 by just using a 2.6.38 kernel). This is /var/log/kernel since the last reload of the module (albeit with debug=65535 as I didn't remember the exact value and couldn't check what you wrote without network access, I hope it's enough info).

Comment 10 Nils Philippsen 2011-11-03 16:23:35 UTC
BTW, while logging this, yum was downloading packages to be installed with a whopping 12-16kB/sec ;-).

Comment 11 Nils Philippsen 2011-11-03 16:24:17 UTC
BTW^2, this is happening with kernel-3.1.0-5.fc16.x86_64.

Comment 12 Stanislaw Gruszka 2011-11-07 11:58:22 UTC
I do not see anything suspicious in logs from comment 9. Can you provide logs as described in comment 8?

Comment 13 Stanislaw Gruszka 2011-11-08 16:19:37 UTC
Also if you still have .38 kernel installed or possibility to install would be good to provide verbose logs in case things works. I could then compare logs, and possibly catch the difference, which most likely would allow to find reason of that problem.

Comment 14 Nils Philippsen 2011-11-10 09:18:10 UTC
Created attachment 532761 [details]
/var/log/kernel of 3.1.0-7 with debugging as requested

Comment 15 Stanislaw Gruszka 2011-12-13 04:46:32 UTC
I'm sorry, but I cannot tell what is wrong based on above logs.

Could you please install working kernel i.e. 2.6.38:
http://koji.fedoraproject.org/koji/buildinfo?buildID=251810
(on F-16 you can do this using using rpm -ivh --force, or you can run F-15 liveCD) and provide the same verbose logs from that kernel?

Then I could compare these two logs and hopefully catch the difference, what should be enough to find fix for that problem. Thanks.


Note You need to log in before you can comment on or make changes to this bug.